﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.UltraChart.Shared.Styles;
using Infragistics.UltraChart.Resources.Appearance;
using Infragistics.UltraChart.Core.Layers;
using Infragistics.Win.UltraWinChart;

namespace SettingLegendForCompositeChart
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            UltraChart ultraChart1=new UltraChart();
            ultraChart1.ChartType = ChartType.Composite;
            this.Controls.Add(ultraChart1);
            ChartArea myChartArea = new ChartArea();
            ultraChart1.CompositeChart.ChartAreas.Add(myChartArea);
            AxisItem axisX = new AxisItem();
            axisX.OrientationType = AxisNumber.X_Axis;
            axisX.DataType = AxisDataType.String;
            axisX.SetLabelAxisType = SetLabelAxisType.GroupBySeries;
            axisX.Labels.ItemFormatString = "<ITEM_LABEL>";
            axisX.Labels.Orientation = TextOrientation.VerticalLeftFacing;

            AxisItem axisY = new AxisItem();
            axisY.OrientationType = AxisNumber.Y_Axis;
            axisY.DataType = AxisDataType.Numeric;
            axisY.Labels.ItemFormatString = "<DATA_VALUE:0.#>";

            myChartArea.Axes.Add(axisX);
            myChartArea.Axes.Add(axisY);
            NumericSeries seriesA = GetNumericSeriesBound();
            NumericSeries seriesB = GetNumericSeriesUnBound();
            ultraChart1.CompositeChart.Series.Add(seriesA);
            ultraChart1.CompositeChart.Series.Add(seriesB);
            ChartLayerAppearance myPieLayer = new ChartLayerAppearance();
            myPieLayer.ChartType = ChartType.PieChart;
            myPieLayer.ChartArea = myChartArea;
            myPieLayer.AxisX = axisX;
            myPieLayer.AxisY = axisY;
            myPieLayer.Series.Add(seriesA);
            myPieLayer.Series.Add(seriesB);
            ultraChart1.CompositeChart.ChartLayers.Add(myPieLayer);
            CompositeLegend myLegend = new CompositeLegend();
            myLegend.ChartLayers.Add(myPieLayer);
            myLegend.Bounds = new Rectangle(0, 75, 20, 25);
            myLegend.BoundsMeasureType = MeasureType.Percentage;
            myLegend.PE.ElementType = PaintElementType.Gradient;
            myLegend.PE.FillGradientStyle = GradientStyle.ForwardDiagonal;
            myLegend.PE.Fill = Color.CornflowerBlue;
            myLegend.PE.FillStopColor = Color.Transparent;
            myLegend.Border.CornerRadius = 10;
            myLegend.Border.Thickness = 0;
            ultraChart1.CompositeChart.Legends.Add(myLegend);


            
        }
        private static NumericSeries GetNumericSeriesBound()
        {
            NumericSeries series = new NumericSeries();
            series.Label = "Series A";
            // this code populates the series from an external data source
            DataTable table = GetData();
            series.Data.DataSource = table;
            series.Data.LabelColumn = "Label Column";
            series.Data.ValueColumn = "Value Column";
            return series;
        }
        private static NumericSeries GetNumericSeriesUnBound()
        {
            NumericSeries series = new NumericSeries();
            series.Label = "Series B";
            // this code populates the series using unbound data
            series.Points.Add(new NumericDataPoint(5.0, "Point A", false));
            series.Points.Add(new NumericDataPoint(4.0, "Point B", false));
            series.Points.Add(new NumericDataPoint(3.0, "Point C", false));
            series.Points.Add(new NumericDataPoint(2.0, "Point D", false));
            series.Points.Add(new NumericDataPoint(1.0, "Point E", false));
            return series;
        }
        private static DataTable GetData()
        {
            DataTable table = new DataTable();
            table.Columns.Add("Label Column", typeof(string));
            table.Columns.Add("Value Column", typeof(double));
            table.Columns.Add("Another Value Column", typeof(double));
            table.Rows.Add(new object[] { "Point A", 1.0, 3.0 });
            table.Rows.Add(new object[] { "Point B", 2.0, 2.0 });
            table.Rows.Add(new object[] { "Point C", 3.0, 1.0 });
            table.Rows.Add(new object[] { "Point D", 4.0, 2.0 });
            table.Rows.Add(new object[] { "Point E", 5.0, 3.0 });
            return table;
        }
    }
}
